.lib "Blitz3d+.dll"


;Camera

BP_GetCamClsMode%( camera,index$ ) : "GetCamClsMode@8" 											; index$ = "Color" Or "Zbuffer" returns 0 Or 1
BP_GetCamClsColorR%( camera ) : "GetCamClsColorR@4"													; returns red component of CameraClsColor
BP_GetCamClsColorG%( camera ) : "GetCamClsColorG@4"													; returns green component of CameraClsColor
BP_GetCamClsColorB%( camera ) : "GetCamClsColorB@4"													; returns blue component of CameraClsColor
BP_GetCamProjMode%( camera ) : "GetCamProjMode@4"														; returns CameraProjMode 0-2
BP_GetCamRangeNear#( camera ) : "GetCamRangeNear@4"													; returns CameraRange "near"
BP_GetCamRangeFar#( camera ) : "GetCamRangeFar@4"														; returns CameraRange "far"
BP_GetCamZoom#( camera ) : "GetCamZoom@4"																		; returns CameraZoom
BP_GetCamViewPortX%( camera ) : "GetCamViewPortX@4"													; returns CameraViewport "x"
BP_GetCamViewPortY%( camera ) : "GetCamViewPortY@4"													; returns CameraViewport "y"
BP_GetCamViewPortW%( camera ) : "GetCamViewPortW@4"													; returns CameraViewport "width"
BP_GetCamViewPortH%( camera ) : "GetCamViewPortH@4"													; returns CameraViewport "height"
BP_GetCamFogMode%( camera ) : "GetCamFogMode@4"															; returns CameraFogMode 0 (none) Or 1 (linear)
BP_GetCamFogNear#( camera ) : "GetCamFogNear@4"															; returns CameraFogRange "near"
BP_GetCamFogFar#( camera ) : "GetCamFogFar@4"																; returns CameraFogRange "far"
BP_GetCamFogColorR%( camera ) : "GetCamFogColorR@4"													; returns red component of CameraFogColor
BP_GetCamFogColorG%( camera ) : "GetCamFogColorG@4"													; returns green component of CameraFogColor
BP_GetCamFogColorB%( camera ) : "GetCamFogColorB@4"													; returns blue component of CameraFogColor
BP_GetCamFOV#( camera ) : "GetCamFOV@4"																			; returns CameraZoom as degrees FOV
BP_SetCamFOV%( camera,FOV# ) : "SetCamFOV@8"																; sets CameraZoom as degrees FOV

;Light

BP_SetLightType%( light,style ) : "SetLightType@8"													; changes LightType on the fly
BP_SetLightDiffuse%( light,red,green,blue,alpha# ) : "SetLightDiffuse@20"		;	sets diffuse rgba ( same as LightColor + alpha component )
BP_SetLightSpecular%( light,red,green,blue,alpha# ) : "SetLightSpecular@20"	;	sets specular rgba ( not normally accessable in b3d )
BP_SetLightAmbient%( light,red,green,blue,alpha# ) : "SetLightAmbient@20"		;	sets specular rgba ( not normally accessable in b3d )
BP_SetLightMaxRange%( light,range# ) : "SetLightMaxRange@8"									; sets absolute LightRange ( not normally accessable in b3d )
BP_SetLightAtten0( light,value# ) : "SetLightAtten0@8"											; attenuation value 0 effects light fall off ( not normally accessable in b3d )
BP_SetLightAtten1( light,value# ) : "SetLightAtten1@8"											; attenuation value 1 effects light fall off ( Not normally accessable in b3d ) 
BP_SetLightFallOff( light,value# ) : "SetLightFallOff@8"										; effects lightcone fall off for spot lights ( not normally accessable in b3d ) 
BP_GetLightType%( light ) : "GetLightType@4"																; returns LightType
BP_GetLightMaxRange#( light ) : "GetLightMaxRange@4"												; returns absolute LightRange ( not normally accessable in b3d )
BP_GetLightRange#( light ) : "GetLightRange@4"															; returns LightRange
BP_GetLightInner#( light ) : "GetLightInner@4"															; returns LightConeAngles "inner angle"
BP_GetLightOuter#( light ) : "GetLightOuter@4"															; returns LightConeAngles "outer angle" 
BP_GetLightDiffuseR%( light ) : "GetLightDiffuseR@4"												; returns red component of lights diffuse Color
BP_GetLightDiffuseG%( light ) : "GetLightDiffuseG@4"												; returns green component of lights diffuse color
BP_GetLightDiffuseB%( light ) : "GetLightDiffuseB@4"												; returns blue component of lights diffuse color
BP_GetLightDiffuseA#( light ) : "GetLightDiffuseA@4"												; returns alpha component of lights diffuse color
BP_GetLightSpecularR%( light ) : "GetLightSpecularR@4"											; returns red component of lights specular color
BP_GetLightSpecularG%( light ) : "GetLightSpecularG@4"											; returns green component of lights specular color
BP_GetLightSpecularB%( light ) : "GetLightSpecularB@4"											; returns blue component of lights specular color
BP_GetLightSpecularA#( light ) : "GetLightSpecularA@4"											; returns alpha component of lights specular Color
BP_GetLightAmbientR%( light ) : "GetLightAmbientR@4"												; returns red component of lights ambient Color
BP_GetLightAmbientG%( light ) : "GetLightAmbientG@4"												; returns green component of lights ambient Color
BP_GetLightAmbientB%( light ) : "GetLightAmbientB@4"												; returns blue component of lights ambient Color
BP_GetLightAmbientA#( light ) : "GetLightAmbientA@4"												; returns alpha component of lights ambient Color
BP_GetLightAtten0#( light ) : "GetLightAtten0@4"														; returns light attenuation value 0
BP_GetLightAtten1#( light ) : "GetLightAtten1@4"														; returns light attenuation value 1
BP_GetLightFallOff#( light ) : "GetLightFallOff@4"													; returns lightcone falloff for spot lights

;Entity

BP_GetEntityAlpha#( entity ) : "GetEntityAlpha@4"														; returns EntityAlpha
BP_GetEntityScaleX#( entity ) : "GetEntityScaleX@4"													; returns EntityScale "x"
BP_GetEntityScaleY#( entity ) : "GetEntityScaleY@4"													; returns EntityScale "y"
BP_GetEntityScaleZ#( entity ) : "GetEntityScaleZ@4"													; returns EntityScale "z"
BP_GetEntityAutoFade%( entity ) : "GetEntityAutoFade@4"											; returns true if EntityAutoFade has been set
BP_ClrEntityAutoFade%( entity ) : "ClrEntityAutoFade@4"											; Cls EntityAutoFade if set
BP_GetEntityAutoNear#( entity ) : "GetEntityAutoNear@4"											; returns EntityAutoFade "near"
BP_GetEntityAutoFar#( entity ) : "GetEntityAutoFar@4"												; returns EntityAutoFade "far"
BP_GetEntityOrder%( entity ) : "GetEntityOrder@4"														; returns EntityOrder
BP_GetNextEntity%( entity ) : "GetNextEntity@4"															; returns entity following this one
BP_GetLastEntity%( entity ) : "GetLastEntity@4"															; returns entity before this one
BP_GetEntityHidden%( entity ) : "GetEntityHidden@4"													; returns true if entity is hidden
BP_GetEntityRadiusX#( entity ) : "GetEntityRadiusX@4"												; returns EntityRadius "x"				
BP_GetEntityRadiusY#( entity ) : "GetEntityRadiusY@4"												; returns EntityRadius "y"
BP_GetEntityBoxX#( entity ) : "GetEntityBoxX@4"															; returns EntityBox "x"
BP_GetEntityBoxY#( entity ) : "GetEntityBoxY@4"															; returns EntityBox "y"
BP_GetEntityBoxZ#( entity ) : "GetEntityBoxZ@4"															; returns EntityBox "z"
BP_GetEntityBoxW#( entity ) : "GetEntityBoxW@4"															; returns EntityBox "width"
BP_GetEntityBoxH#( entity ) : "GetEntityBoxH@4"															; returns EntityBox "height"
BP_GetEntityBoxD#( entity ) : "GetEntityBoxD@4"															; returns EntityBox "depth"
BP_GetEntityPickmode%( entity ) : "GetEntityPickmode@4"											; returns EntityPickMode 0-3
BP_GetEntityObscurer%( entity ) : "GetEntityObscurer@4"											; returns true if entity obscures others, set by EntityPickMode
BP_GetEntityColorR%( entity ) : "GetEntityColorR@4"													; returns red component of EntityColor
BP_GetEntityColorG%( entity ) : "GetEntityColorG@4"													; returns green component of EntityColor
BP_GetEntityColorB%( entity ) : "GetEntityColorB@4"													; returns blue component of EntityColor
BP_GetEntityShine#( entity ) : "GetEntityShine@4"			 											; returns EntityShininess
BP_GetEntityBlend%( entity ) : "GetEntityBlend@4"														; returns EntityBlend
BP_GetEntityFX%( entity ) : "GetEntityFX@4"																	; returns EntityFX


;Texture

BP_GetTextureBlend%( texture ) : "GetTextureBlend@4"												; returns TextureBlend
BP_GetTextureCoords%( texture ) : "GetTextureCoords@4"											; returns TextureCoords
BP_GetTextureScaleU#( texture ) : "GetTextureScaleU@4"											; returns ScaleTexture "u"
BP_GetTextureScaleV#( texture ) : "GetTextureScaleV@4"											; returns ScaleTexture "v"
BP_GetTexturePositionU#( texture ) : "GetTexturePositionU@4"								; returns PositionTexture "u"
BP_GetTexturePositionV#( texture ) : "GetTexturePositionV@4"								; returns PositionTexture "v"
BP_GetTextureRotation#( texture ) : "GetTextureRotation@4"									; returns texture rotation
BP_GetTextureFlags%( texbuffer ) : "GetTextureFlags@4"											; returns texture flags
BP_ScrollTexture#( texture,u#,v# ) : "ScrollTexture@12"											; scrolls texture by relative amount

;Brush

BP_GetBrushBlend%( brush ) : "GetBrushBlend@4"															; returns BrushBlend 1-3
BP_GetBrushColorRGB%( brush ) : "GetBrushColorRGB@4"												; returns BrushColor as an integer
BP_GetBrushColorR%( brush ) : "GetBrushColorR@4"														; returns red component of BrushColor
BP_GetBrushColorG%( brush ) : "GetBrushColorG@4"														; returns green component of BrushColor
BP_GetBrushColorB%( brush ) : "GetBrushColorB@4"														; returns blue component of BrushColor
BP_GetBrushFX%( brush ) : "GetBrushFX@4"																		; returns BrushFX
BP_GetBrushShininess#( brush ) : "GetBrushShininess@4"											; returns BrushShininess
BP_GetBrushAlpha#( brush ) : "GetBrushAlpha@4"															; returns BrushAlpha
BP_GetBrushNumTextures%( brush ) : "GetBrushNumTextures@4"									; returns number of textures used by this brush
BP_SetBrushTexture%( brush,index,texture ) : "SetBrushTexture@12"						; Changes Brush texture on the fly, texture=0 to clear texture
																																						; If already applied to entity use RefreshEntityBrush() to update entity
BP_RefreshEntityBrush%( entity ) : "RefreshEntityBrush@4"										; updates entity brush structure
;Sprite

BP_GetSpriteHandleX#( sprite ) : "GetSpriteHandleX@4"												; returns HandleSprite "x"
BP_GetSpriteHandleY#( sprite ) : "GetSpriteHandleY@4"												; returns HandleSprite "y"
BP_GetSpriteAngle#( sprite ) : "GetSpriteAngle@4"														; returns angle set by RotateSprite
BP_GetSpriteScaleX#( sprite ) : "GetSpriteScaleX@4"													; returns ScaleSprite "x"
BP_GetSpriteScaleY#( sprite ) : "GetSpriteScaleY@4"													; returns ScaleSprite "y"
BP_GetSpriteViewMode%( sprite ) : "GetSpriteViewMode@4"											; returns SpriteViewMode

;Color Conversion

BP_GetIntRed%( IntColor ) : "GetIntRed@4"																		; returns red component of an integer 
BP_GetIntGreen%( IntColor ) : "GetIntGreen@4"																; returns green component of an integer
BP_GetIntBlue%( IntColor ) : "GetIntBlue@4"																	; returns blue component of an integer
BP_GetIntAlpha%( IntColor ) : "GetIntAlpha@4"																; returns alpha component of an integer
BP_GetRGBInt%( r,g,b ) : "GetRGBInt@12"																			; converts r,g,b to integer
BP_GetRGBAInt%( r,g,b,a ) : "GetRGBAInt@16"																	; converts r,g,b,a To integer

;Math

BP_CurveValue#( newvalue#,oldvalue#,increments# ) : "CurveValue@12"
BP_WrapValue#( value#,lo#,hi# ) : "WrapValue@12"
BP_ClampValue#( value#,lo#,hi# ) : "ClampValue@12"
BP_Min#( value1#,value2# ) : "Min@8"
BP_Max#( value1#,value2# ) : "Max@8"
BP_Distance2d#( x1#,y1#,x2#,y2# ) : "Distance2D@16"
BP_Distance3d#( x1#,y1#,z1#,x2#,y2#,z2# ) : "Distance3D@24"
BP_PointInRect#( x1#,y1#,rx#,ry#,rw#,rh# ) : "PointInRect@24"

;Memory

BP_PeekByte%( address ) : "PeekByte@4"
BP_PeekShort%( address ) : "PeekShort@4"
BP_PeekInt%( address ) : "PeekInt@4"
BP_PeekFloat#( address ) : "PeekFloat@4"

BP_PokeByte( address,value% ) : "PokeByte@8"
BP_PokeShort( address,value% ) : "PokeShort@8"
BP_PokeInt( address,value% ) : "PokeInt@8"
BP_PokeFloat( address,value# ) : "PokeFloat@8"