

''
'' all FB functions are by default STDCALL on Windows and also PUBLIC, 
'' so nothing else has to be added (note that FBC will not include "mydll" 
'' to linker's list when creating the DLL, only when using it on an .exe)
''

Declare Function Distance2D Lib "Blitz3d+" Alias "Distance2D" ( ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single ) As Single

Declare Function Distance3D Lib "Blitz3d+" Alias "Distance3D" ( ByVal x1 As Single, ByVal y1 As Single, ByVal z1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal z2 As Single ) As Single

Declare Function PointInRect Lib "Blitz3d+" Alias "PointInRect" ( ByVal x As Single, ByVal y As Single, ByVal rx As Single, ByVal ry As Single, ByVal rw As Single, ByVal rh As Single ) As Single


'Camera'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 

Declare Function GetCamClsMode Lib "Blitz3d+" Alias "GetCamClsMode" (ByVal camera As Any Ptr, ByVal index As String ) As Integer

Declare Function GetCamClsColorR Lib "Blitz3d+" Alias "GetCamClsColorR" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamClsColorG Lib "Blitz3d+" Alias "GetCamClsColorG" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamClsColorB Lib "Blitz3d+" Alias "GetCamClsColorB" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamProjMode Lib "Blitz3d+" Alias "GetCamProjMode" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamRangeNear Lib "Blitz3d+" Alias "GetCamRangeNear" ( ByVal camera As Any Ptr ) As Single

Declare Function GetCamRangeFar Lib "Blitz3d+" Alias "GetCamRangeFar" ( ByVal camera As Any Ptr ) As Single

Declare Function GetCamZoom Lib "Blitz3d+" Alias "GetCamZoom" ( ByVal camera As Any Ptr ) As Single

Declare Function GetCamViewPortX Lib "Blitz3d+" Alias "GetCamViewPortX" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamViewPortY Lib "Blitz3d+" Alias "GetCamViewPortY" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamViewPortW Lib "Blitz3d+" Alias "GetCamViewPortW" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamViewPortH Lib "Blitz3d+" Alias "GetCamViewPortH" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamFogMode Lib "Blitz3d+" Alias "GetCamFogMode" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamFogNear Lib "Blitz3d+" Alias "GetCamFogNear" ( ByVal camera As Any Ptr ) As Single

Declare Function GetCamFogFar Lib "Blitz3d+" Alias "GetCamFogFar" ( ByVal camera As Any Ptr ) As Single

Declare Function GetCamFogColorR Lib "Blitz3d+" Alias "GetCamFogColorR" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamFogColorG Lib "Blitz3d+" Alias "GetCamFogColorG" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamFogColorB Lib "Blitz3d+" Alias "GetCamFogColorB" ( ByVal camera As Any Ptr ) As Integer

Declare Function GetCamFOV Lib "Blitz3d+" Alias "GetCamFOV" ( ByVal camera As Any Ptr ) As Single

Declare Sub SetCamFOV Lib "Blitz3d+" Alias "SetCamFOV" ( ByVal camera As Any Ptr, ByVal FOV As Single )

' Light

Declare Sub SetLightType Lib "Blitz3d+" Alias "SetLightType" ( ByVal light As Any Ptr, ByVal lighttype As Integer )

Declare Sub SetLightDiffuse Lib "Blitz3d+" Alias "SetLightDiffuse" ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single )

Declare Sub SetLightSpecular Lib "Blitz3d+" Alias "SetLightSpecular" ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single )

Declare Sub SetLightAmbient Lib "Blitz3d+" Alias "SetLightAmbient" ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single )

Declare Sub SetLightMaxRange Lib "Blitz3d+" Alias "SetLightMaxRange" ( ByVal light As Any Ptr, ByVal range As Single )

Declare Function GetLightType Lib "Blitz3d+" Alias "GetLightType" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightMaxRange Lib "Blitz3d+" Alias "GetLightMaxRange" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightRange Lib "Blitz3d+" Alias "GetLightRange" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightInner Lib "Blitz3d+" Alias "GetLightInner" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightOuter Lib "Blitz3d+" Alias "GetLightOuter" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightDiffuseR Lib "Blitz3d+" Alias "GetLightDiffuseR" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightDiffuseG Lib "Blitz3d+" Alias "GetLightDiffuseG" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightDiffuseB Lib "Blitz3d+" Alias "GetLightDiffuseB" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightDiffuseA Lib "Blitz3d+" Alias "GetLightDiffuseA" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightSpecularR Lib "Blitz3d+" Alias "GetLightSpecularR" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightSpecularG Lib "Blitz3d+" Alias "GetLightSpecularG" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightSpecularB Lib "Blitz3d+" Alias "GetLightSpecularB" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightSpecularA Lib "Blitz3d+" Alias "GetLightSpecularA" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightAmbientR Lib "Blitz3d+" Alias "GetLightAmbientR" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightAmbientG Lib "Blitz3d+" Alias "GetLightAmbientG" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightAmbientB Lib "Blitz3d+" Alias "GetLightAmbientB" ( ByVal light As Any Ptr ) As Integer

Declare Function GetLightAmbientA Lib "Blitz3d+" Alias "GetLightAmbientA" ( ByVal light As Any Ptr ) As Single

Declare Sub SetLightAtten0 Lib "Blitz3d+" Alias "SetLightAtten0" ( ByVal light As Any Ptr, ByVal value As Single )

Declare Sub SetLightAtten1 Lib "Blitz3d+" Alias "SetLightAtten1" ( ByVal light As Any Ptr, ByVal value As Single )

Declare Sub SetLightFallOff Lib "Blitz3d+" Alias "SetLightAtten2" ( ByVal light As Any Ptr, ByVal value As Single )

Declare Function GetLightAtten0 Lib "Blitz3d+" Alias "GetLightAtten0" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightAtten1 Lib "Blitz3d+" Alias "GetLightAtten1" ( ByVal light As Any Ptr ) As Single

Declare Function GetLightFallOff Lib "Blitz3d+" Alias "GetLightFallOff" ( ByVal light As Any Ptr ) As Single


' Entity ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function GetEntityAlpha Lib "Blitz3d+" Alias "GetEntityAlpha" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityScaleX Lib "Blitz3d+" Alias "GetEntityScaleX" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityScaleY Lib "Blitz3d+" Alias "GetEntityScaleY" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityScaleZ Lib "Blitz3d+" Alias "GetEntityScaleZ" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityAutoFade Lib "Blitz3d+" Alias "GetEntityAutoFade" ( ByVal entity As Any Ptr ) As Integer

Declare Sub ClrEntityAutoFade Lib "Blitz3d+" Alias "ClrEntityAutoFade" ( ByVal entity As Any Ptr )

Declare Function GetEntityAutoNear Lib "Blitz3d+" Alias "GetEntityAutoNear" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityAutoFar Lib "Blitz3d+" Alias "GetEntityAutoFar" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityOrder Lib "Blitz3d+" Alias "GetEntityOrder" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetNextEntity Lib "Blitz3d+" Alias "GetNextEntity" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetLastEntity Lib "Blitz3d+" Alias "GetLastEntity" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityHidden Lib "Blitz3d+" Alias "GetEntityHidden" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityRadiusX Lib "Blitz3d+" Alias "GetEntityRadiusX" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityRadiusY Lib "Blitz3d+" Alias "GetEntityRadiusY" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxX Lib "Blitz3d+" Alias "GetEntityBoxX" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxY Lib "Blitz3d+" Alias "GetEntityBoxY" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxZ Lib "Blitz3d+" Alias "GetEntityBoxZ" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxW Lib "Blitz3d+" Alias "GetEntityBoxW" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxH Lib "Blitz3d+" Alias "GetEntityBoxH" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBoxD Lib "Blitz3d+" Alias "GetEntityBoxD" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityPickmode Lib "Blitz3d+" Alias "GetEntityPickmode" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityObscurer Lib "Blitz3d+" Alias "GetEntityObscurer" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityColorR Lib "Blitz3d+" Alias "GetEntityColorR" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityColorG Lib "Blitz3d+" Alias "GetEntityColorG" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityColorB Lib "Blitz3d+" Alias "GetEntityColorB" ( ByVal entity As Any Ptr ) As Integer

Declare Function GetEntityShine Lib "Blitz3d+" Alias "GetEntityShine" ( ByVal entity As Any Ptr ) As Single

Declare Function GetEntityBlend Lib "Blitz3d+" Alias "GetEntityBlend" ( ByVal entity As Any Ptr ) As uInteger

Declare Function GetEntityFX Lib "Blitz3d+" Alias "GetEntityFX" ( ByVal entity As Any Ptr ) As uInteger

Declare Sub RefreshEntityBrush Lib "Blitz3d+" Alias "RefreshEntityBrush" ( ByVal entity As Any Ptr )

' Texture''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function GetTextureBlend Lib "Blitz3d+" Alias "GetTextureBlend" ( ByVal texture As Any Ptr ) As Integer

Declare Function GetTextureCoords Lib "Blitz3d+" Alias "GetTextureCoords" ( ByVal texture As Any Ptr ) As Integer

Declare Function GetTextureScaleU Lib "Blitz3d+" Alias "GetTextureScaleU" ( ByVal texture As Any Ptr ) As Single

Declare Function GetTextureScaleV Lib "Blitz3d+" Alias "GetTextureScaleV" ( ByVal texture As Any Ptr ) As Single

Declare Function GetTexturePositionU Lib "Blitz3d+" Alias "GetTexturePositionU" ( ByVal texture As Any Ptr ) As Single

Declare Function GetTexturePositionV Lib "Blitz3d+" Alias "GetTexturePositionV" ( ByVal texture As Any Ptr ) As Single

Declare Sub ScrollTexture Lib "Blitz3d+" Alias "ScrollTexture" ( ByVal texture As Any Ptr, UIncrement As Single, VIncrement As Single )

Declare Function GetTextureRotation Lib "Blitz3d+" Alias "GetTextureRotation" ( ByVal texture As Any Ptr ) As Single

Declare Function GetTextureFlags Lib "Blitz3d+" Alias "GetTextureFlags" ( ByVal texbuffer As Any Ptr ) As Integer

Declare Function GetTextureBuffer Lib "Blitz3d+" Alias "GetTextureBuffer"( ByVal texture As Any Ptr ) As Integer

'Brush''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function GetBrushBlend Lib "Blitz3d+" Alias "GetBrushBlend" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushColorRGB Lib "Blitz3d+" Alias "GetBrushColorRGB" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushColorR Lib "Blitz3d+" Alias "GetBrushColorR" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushColorG Lib "Blitz3d+" Alias "GetBrushColorG" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushColorB Lib "Blitz3d+" Alias "GetBrushColorB" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushFX Lib "Blitz3d+" Alias "GetBrushFX" ( ByVal brush As Any Ptr ) As Integer

Declare Function GetBrushShininess Lib "Blitz3d+" Alias "GetBrushShininess" ( ByVal brush As Any Ptr ) As Single

Declare Function GetBrushAlpha Lib "Blitz3d+" Alias "GetBrushAlpha" ( ByVal brush As Any Ptr ) As Single

Declare Function GetBrushNumTextures Lib "Blitz3d+" Alias "GetBrushNumTextures" ( ByVal brush As Any Ptr ) As Integer 

Declare Sub SetBrushTexture Lib "Blitz3d+" Alias "SetBrushTexture" ( ByVal brush As Any Ptr, ByVal index As Integer, ByVal texture As Any Ptr )

'Sprites''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function GetSpriteHandleX Lib "Blitz3d+" Alias "GetSpriteHandleX" ( ByVal sprite As Any Ptr ) As Single

Declare Function GetSpriteHandleY Lib "Blitz3d+" Alias "GetSpriteHandleY" ( ByVal sprite As Any Ptr ) As Single

Declare Function GetSpriteAngle Lib "Blitz3d+" Alias "GetSpriteAngle" ( ByVal sprite As Any Ptr ) As Single

Declare Function GetSpriteScaleX Lib "Blitz3d+" Alias "GetSpriteScaleX" ( ByVal sprite As Any Ptr ) As Single

Declare Function GetSpriteScaleY Lib "Blitz3d+" Alias "GetSpriteScaleY" ( ByVal sprite As Any Ptr ) As Single

Declare Function GetSpriteViewMode Lib "Blitz3d+" Alias "GetSpriteViewMode" ( ByVal sprite As Any Ptr ) As Integer


'Color Functions''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function GetIntRed Lib "Blitz3d+" Alias "GetIntRed" ( ByVal hue As Integer ) As Integer

Declare Function GetIntGreen Lib "Blitz3d+" Alias "GetIntGreen" ( ByVal hue As Integer ) As Integer

Declare Function GetIntBlue Lib "Blitz3d+" Alias "GetIntBlue" ( ByVal hue As Integer ) As Integer

Declare Function GetIntAlpha Lib "Blitz3d+" Alias "GetIntAlpha" ( ByVal hue As Integer ) As Integer

Declare Function GetRGBInt Lib "Blitz3d+" Alias "GetRGBInt" ( ByVal r As uInteger, ByVal g As uInteger, ByVal b As uInteger ) As uInteger

Declare Function GetRGBAInt Lib "Blitz3d+" Alias "GetRGBAInt" ( ByVal r As uInteger, ByVal g As uInteger, ByVal b As uInteger, ByVal a As uInteger ) As uInteger


'Memory'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function PeekByte Lib "Blitz3d+" Alias "PeekByte" ( ByVal address As Any Ptr ) As Integer

Declare Function PeekShort Lib "Blitz3d+" Alias "PeekShort" ( ByVal address As Any Ptr ) As Integer

Declare Function PeekInt Lib "Blitz3d+" Alias "PeekInt" ( ByVal address As Any Ptr ) As unSigned Integer

Declare Function PeekFloat Lib "Blitz3d+" Alias "PeekFloat" ( ByVal address As Any Ptr ) As Single

Declare Sub PokeByte Lib "Blitz3d+" Alias "PokeByte" ( ByVal address As Any Ptr, ByVal value As uByte )

Declare Sub  PokeShort Lib "Blitz3d+" Alias "PokeShort" ( ByVal address As Any Ptr, ByVal value As Short )

Declare Sub PokeInt Lib "Blitz3d+" Alias "PokeInt" ( ByVal address As Any Ptr, ByVal value As Integer )

Declare Sub PokeFloat Lib "Blitz3d+" Alias "PokeFloat" ( ByVal address As Any Ptr, ByVal value As Single )


'Math'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function CurveValue Lib "Blitz3d+" Alias "CurveValue" ( ByVal newvalue As Single, ByVal oldvalue As Single , ByVal increments As Single ) As Single

Declare Function WrapValue Lib "Blitz3d+" Alias "WrapValue" (ByVal value As Single, ByVal lo As Single, ByVal hi As Single) As Single

Declare Function ClampValue Lib "Blitz3d+" Alias "ClampValue" (ByVal value As Single, ByVal lo As Single, ByVal hi As Single) As Single

Declare Function Min Lib "Blitz3d+" Alias "Min" (ByVal value1 As Single, ByVal value2 As Single) As Single

Declare Function Max Lib "Blitz3d+" Alias "Max" (ByVal value1 As Single, ByVal value2 As Single) As Single